<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino Project Develop branch</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
 //Vùng khai báo biến global
    const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
    const gREQUEST_STATUS_OK = 200;
//gán sự kiện click
$(document).ready(function(){
    $("#btn-dice").click(function(){
        var bInputData = {
            username:"",
            firstname:"",
            lastname:""
        };
        getData(bInputData);
        const vBaseUrl = "http://42.115.221.44:8080/devcamp-lucky-dice/";
            const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
            var vXmlHttpDice = new XMLHttpRequest();
        if (validate(bInputData)){ 
            addData(vXmlHttpDice, bInputData, vBaseUrl,vUtf8TextApplicationHeader)
                vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                    && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    console.log(vXmlHttpDice.responseText);
                    var vResultDice = JSON.parse(vXmlHttpDice.responseText);
                    displayDiceAndMessage(vResultDice.dice);
                    displayVoucher(vResultDice.voucher);
                    displayPrize(vResultDice.prize);
                
                }
            }

            }
        
    })
})

//hàm đọc dữ liệu
function getData(paramInput){
    paramInput.username = $("#inp-user-name").val().trim();
    paramInput.firstname = $("#inp-first-name").val().trim();
    paramInput.lastname = $("#inp-last-name").val().trim();

}
//hàm kiểm tra dữ liệu
function validate(paramInput){
    var vInputUsername = $("#inp-user-name").val().trim();
    var vInputFirstname = $("#inp-first-name").val().trim();
    var vInputLastname = $("#inp-last-name").val().trim();

    if (vInputUsername=="" || vInputFirstname=="" || vInputLastname==""){
        alert ("Bạn chưa nhập đủ dữ liệu!")
        return false
    }
    return true
}
//hàm gọi API
function addData(paramXmlHttpDice, paramInput, paramUrl,paramUtf8TextApplicationHeader){
    paramXmlHttpDice.open("POST", paramUrl + "/dice", true);
    paramXmlHttpDice.setRequestHeader("Content-Type", paramUtf8TextApplicationHeader);
    paramXmlHttpDice.send(JSON.stringify(paramInput));  //chuyển Json object sang string
    }

//hàm hiển thị dice mới và lời nhắn
function displayDiceAndMessage(paramResultDice){
    if (paramResultDice==1){
        $("#img-dice").attr("src","LuckyDiceImages/1.png");
        $("#p-notification-dice").html("Thử lại lần nữa!")
    } else if (paramResultDice==2){
        $("#img-dice").attr("src","LuckyDiceImages/2.png");
        $("#p-notification-dice").html("Thử lại lần nữa!")
    } else if (paramResultDice==3){
        $("#img-dice").attr("src","LuckyDiceImages/3.png");
        $("#p-notification-dice").html("Thử lại lần nữa!")
    } else if (paramResultDice==4){
        $("#img-dice").attr("src","LuckyDiceImages/4.png");
        $("#p-notification-dice").html("Chúc mừng bạn!")
    } else if (paramResultDice==5){
        $("#img-dice").attr("src","LuckyDiceImages/5.png");
        $("#p-notification-dice").html("Chúc mừng bạn!")
    } else if (paramResultDice==6){
        $("#img-dice").attr("src","LuckyDiceImages/6.png");
        $("#p-notification-dice").html("Chúc mừng bạn!")
    }
}
//hàm hiển thị voucher ID và %discount
function displayVoucher(paramResult){
    $("#p-voucher-id").html(paramResult.maVoucher);
    $("#p-voucher-percent").html(paramResult.phanTramGiamGia + "%");
}
//hàm hiển thị phần thưởng
function displayPrize(paramResult){
    if (paramResult==null){
        $("#img-present").attr("src","LuckyDiceImages/no-present.jpg");
    } else if (paramResult=="Mũ"){
        $("#img-present").attr("src","LuckyDiceImages/hat.jpg");
    } else if (paramResult=="Áo"){
        $("#img-present").attr("src","LuckyDiceImages/t-shirt.jpg");
    } else if (paramResult=="Xe máy"){
        $("#img-present").attr("src","LuckyDiceImages/xe-may.jpg");
    } else if (paramResult=="Ô tô"){
        $("#img-present").attr("src","LuckyDiceImages/car.jpg");
    }
}

</script>

</html>